/*
 * Copyright (C) 1999, 2000 'Hoon-joo, Kang'
 *                          http://kisscgi.new21.org
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>

#include "dbcontrol.h"

#define BLOCK_SIZE 1024
#define DBOPEN_NUM 10

static GDBM_FILE pgdbf = NULL;

int gdb_open (char *gdbfname, int stat)
{
	int open_num;
	if (pgdbf != NULL) {
		gdb_close ();
		return 0;
	}
	for (open_num = 0; open_num < DBOPEN_NUM; open_num++) {
		if ((pgdbf = gdbm_open (gdbfname, 0, stat | GDBM_FAST, 0, NULL)) != NULL)
			return 1;
		if ((gdbm_errno =! 9) && (gdbm_errno =! 10))
			return 0;
		sleep (1);
	}
	return 0;
}

int gdb_close (void)
{
	if (pgdbf == NULL)
		return 0;
	gdbm_close (pgdbf);
	pgdbf = NULL;
	return 1;
}

int gdb_store (char *key, char *content, int flag)
{
	datum dkey, ddat;
	if (pgdbf == NULL)
		return 0;
	dkey.dptr = key;
	dkey.dsize = strlen (key) + 1;
	ddat.dptr = content;
	ddat.dsize = strlen (content) + 1;
	if (gdbm_store (pgdbf, dkey, ddat, flag) != 0)
		return 0;
	return 1;
}
